/******************************************************************************/
//    File Name     : Model2.java
//                            Java Applet source file
//    Name          : Yoshiyuki Tanaka
//                    (e-Mail : tanaka_y@jaist.ac.jp)
//    Class Name    :     1.Model2()
/******************************************************************************/

/******************************************************************************/
//                                  IMPORT
/******************************************************************************/
import java.awt.*;

/******************************************************************************/
//    Class Name    : Model2
/******************************************************************************/
public class Model2{

    /***** VALUE DATA *****/
    public    static Model2Param param = new Model2Param();

    protected        Dimension   dim   = new Dimension(0, 0);
    protected        int         u     = 0;
    protected        int         myu   = 0;


    /***** CONSTRUCTOR *****/
    /**************************************************************************/
    //    Method        : Model2()
    /**************************************************************************/
    Model2(int _u, int _myu){ this.u   = _u; this.myu = _myu; }

    Model2(int _u){ this(_u, 0) ;}
    Model2()      { this( 0, 0) ;}

    /***** METHOD DATA *****/
    /**************************************************************************/
    //    Method Name   : reset()
    /**************************************************************************/
    protected void  reset(){ this.u = 0; this.myu = 0; }

    /**************************************************************************/
    //    Method Name   : setModel2()
    /**************************************************************************/
    protected void setCell(int _u){ this.u   = _u; this.myu = 0; }

    protected void setdim(){
        this.dim.width  = (int)( param.getd() * Math.random() );
        this.dim.height = (int)( param.getd() * Math.random() );
    }

    /**************************************************************************/
    //    Method Name   : step()
    /**************************************************************************/
    protected void step(int v){
        if( v >= (param.getm0() + param.getp() * this.u) )
            this.myu = param.getn() + 1;
        else
           this.myu = (this.u == 0)?0:(this.u - 1);
    }

    protected void step(){ this.myu = u - 1; }

    /**************************************************************************/
    //    Method Name   : renewalState()
    /**************************************************************************/
    protected void renewalState(int avr){ u = avr; }
    protected void renewalState()       { u = myu; }

    /**************************************************************************/
    //    Method Name   : check
    /**************************************************************************/
    public boolean checkRefractry(){ return ( this.u <= param.getref() ); }
    public boolean checkUnExcited(){ return (2 <= this.myu)&&(this.myu <= param.getn()); }
    public boolean checkExcited()  { return ( this.u > param.getn() ); }

    /**************************************************************************/
    //    Method Name   : get
    /**************************************************************************/
    public int       getu() { return this.u; }
    public int       getmyu(){ return this.myu; }
    public Dimension getdim(){ return this.dim; };

    /**************************************************************************/
    //    Method Name   : getColor()
    /**************************************************************************/
    public Color     getColor(){
        int colorlevel = (int)(240 * this.u)/( (param.getn() + 1) );
        return new Color(colorlevel,colorlevel,colorlevel);
    }

}

/**** END_of_file: Model2.java **************************************************/
