/******************************************************************************/
//    File Name     : Model2s.java
//                            Java Applet source file
//    Name          : Yoshiyuki Tanaka
//                    (e-Mail : tanaka_y@jaist.ac.jp)
//    Class Name    :     1.Model2s()
/******************************************************************************/

/******************************************************************************/
//                                  IMPORT
/******************************************************************************/
import java.awt.*;

 /******************************************************************************/
//    Class Name    : Model2s
/******************************************************************************/
public class Model2s{

    /***** VALUE DATA *****/
    protected static Dimension   dim   = new Dimension(200, 200);
    protected static int         time  = 0;
    public    static Model2[][]  cell  = new Model2[dim.height][dim.width];
    public    static Model2Param param = new Model2Param();

    /***** CONSTRUCTOR *****/
    public Model2s(){
        for(int i = 0; i < cell.length; i++)
            for(int j = 0; j < cell[i].length; cell[i][j++] = new Model2() );
    }

    /***** METHOD DATA *****/
    /**************************************************************************/
    //    Method Name   : reset()
    /**************************************************************************/
    public void reset(){
        for(int i = 0; i < cell.length; i++)
            for(int j = 0; j < cell[i].length; cell[i][j++].reset() );
        time = 0;
    }

    /**************************************************************************/
    //    Method Name   : grow()
    /**************************************************************************/
    public void grow()
    {
        int R = param.getR();
        int d = param.getd();
        int r = (int)(R/d) + 1;

        for(int i = 0; i < cell.length; i++){
            for(int j = 0; j < cell[i].length; j++){
                cell[i][j].setdim();
                if( cell[i][j].checkRefractry() ){
                    int v = 0;
                    int x0 = cell[i][j].getdim().width;
                    int y0 = cell[i][j].getdim().height;

                    for(int ri = -r; ri <= r; ri++){
                        if(  ( (i + ri) < 0 )||( cell.length <= (i + ri) )  ) continue;

                        for(int rj = -r; rj <= r; rj++){
                            if(  ( (j + rj) < 0 )||( cell[i].length <= (j + rj) )  ) continue;

                            if( (ri == 0)&&(rj == 0) ) continue;
                            int x1 = cell[i + ri][j + rj].getdim().width;
                            int y1 = cell[i + ri][j + rj].getdim().height;
                            int x = (ri < 0)?(x0 - x1 - ri * d):(x1 - x0 + ri * d);
                            int y = (rj < 0)?(y1 - y0 - rj * d):(y1 - y0 + rj * d);
                            if( (x*x + y*y) <= R*R ){
                                if( cell[i + ri][j + rj].checkExcited() )
                                     v++;
                            }
                        }
                    }
                    cell[i][j].step(v);

                }else cell[i][j].step();
            }
        }


        for(int i = 0; i < cell.length; i++){
            for(int j = 0; j < cell[i].length; j++){
                if( cell[i][j].checkUnExcited() ){
                    int myu_cnt   = 1;
                    int sigma_myu = cell[i][j].getmyu();

                    int x0 = cell[i][j].getdim().width;
                    int y0 = cell[i][j].getdim().height;
                    for(int ri = -r; ri <=  r; ri++){
                        if(  ( (i + ri) < 0 )||( cell.length <= (i + ri) )  ) continue;

                        for(int rj = -r; rj <= r; rj++){
                            if(  ( (j + rj) < 0 )||( cell[i].length <= (j + rj) )  ) continue;

                            if( (ri == 0)&&(rj == 0) ) continue;
                            int x1 = cell[i + ri][j + rj].getdim().width;
                            int y1 = cell[i + ri][j + rj].getdim().height;
                            int x = (ri < 0)?(x0 - x1 - ri * d):(x1 - x0 + ri * d);
                            int y = (rj < 0)?(y1 - y0 - rj * d):(y1 - y0 + rj * d);

                            if( (x*x + y*y) <= R*R ){
                                    myu_cnt++;
                                    sigma_myu += cell[i + ri][j + rj].getmyu();
                            }
                        }
                    }
                    int avr = (int)(sigma_myu/myu_cnt);
                    avr = (avr == sigma_myu/myu_cnt)?(avr):(avr+1);
                    cell[i][j].renewalState(avr);
                }else cell[i][j].renewalState();
            }
        }
        this.time++;
    }

    /**************************************************************************/
    //    Method Name   : getdim()
    //    Method Name   : gettime()
    /**************************************************************************/
    public Dimension getdim() { return dim ;}
    public int       gettime(){ return time ;}

}


/**** END_of_file: Model2s.java *************************************************/
